#define stack_address( code)                                       \
   (0x100 | code->SP)

#define imm_address( code)                                         \
   (code->PC++)

#define zero_address( code)                                        \
   code->Me [imm_address( code)]

#define zero_x_address( code)                                      \
   (zero_address( code) + code->Xr) & 0xFF

#define abs_address( code)                                         \
  (code->PC += 2,                                                  \
   code->Me [code->PC - 2] | code->Me [code->PC - 1] << 8)

#define abs_x_address( code)                                       \
   abs_address( code) + code->Xr

#define abs_y_address( code)                                       \
   abs_address( code) + code->Yr

#define ind_x_address( code)                                       \
  (code->PC++,                                                     \
   code->Me [(code->Me [code->PC - 1] + code->Xr) % 0xFF]      |   \
   code->Me [(code->Me [code->PC - 1] + code->Xr + 1) % 0xFF] << 8)

#define ind_y_address( code)                                       \
  (code->PC ++,                                                    \
   (code->Me [code->Me [code->PC - 1]] |                           \
    code->Me [code->Me [code->PC - 1] + 1] << 8) + code->Yr)

#define set_neg_zero_stat( code, register)                         \
   code->Ne = (register >= 0x80);                                  \
   code->Ze = (register == 0)


